# py-scibec-openapi-client
scibec

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.14.2
- Package version: 1.0.0
- Generator version: 7.4.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import py_scibec_openapi_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import py_scibec_openapi_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import py_scibec_openapi_client
from py_scibec_openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = py_scibec_openapi_client.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization (JWT): jwt
configuration = py_scibec_openapi_client.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with py_scibec_openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = py_scibec_openapi_client.AccessAccountControllerApi(api_client)
    where = None # Dict[str, object] |  (optional)

    try:
        api_response = api_instance.access_account_controller_count(where=where)
        print("The response of AccessAccountControllerApi->access_account_controller_count:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AccessAccountControllerApi->access_account_controller_count: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccessAccountControllerApi* | [**access_account_controller_count**](docs/AccessAccountControllerApi.md#access_account_controller_count) | **GET** /access-accounts/count | 
*AccessAccountControllerApi* | [**access_account_controller_create**](docs/AccessAccountControllerApi.md#access_account_controller_create) | **POST** /access-accounts | 
*AccessAccountControllerApi* | [**access_account_controller_delete_by_id**](docs/AccessAccountControllerApi.md#access_account_controller_delete_by_id) | **DELETE** /access-accounts/{id} | 
*AccessAccountControllerApi* | [**access_account_controller_find**](docs/AccessAccountControllerApi.md#access_account_controller_find) | **GET** /access-accounts | 
*AccessAccountControllerApi* | [**access_account_controller_find_by_id**](docs/AccessAccountControllerApi.md#access_account_controller_find_by_id) | **GET** /access-accounts/{id} | 
*AccessAccountControllerApi* | [**access_account_controller_update_all**](docs/AccessAccountControllerApi.md#access_account_controller_update_all) | **PATCH** /access-accounts | 
*AccessAccountControllerApi* | [**access_account_controller_update_by_id**](docs/AccessAccountControllerApi.md#access_account_controller_update_by_id) | **PATCH** /access-accounts/{id} | 
*AccessConfigControllerApi* | [**access_config_controller_count**](docs/AccessConfigControllerApi.md#access_config_controller_count) | **GET** /access-configs/count | 
*AccessConfigControllerApi* | [**access_config_controller_create**](docs/AccessConfigControllerApi.md#access_config_controller_create) | **POST** /access-configs | 
*AccessConfigControllerApi* | [**access_config_controller_delete_by_id**](docs/AccessConfigControllerApi.md#access_config_controller_delete_by_id) | **DELETE** /access-configs/{id} | 
*AccessConfigControllerApi* | [**access_config_controller_find**](docs/AccessConfigControllerApi.md#access_config_controller_find) | **GET** /access-configs | 
*AccessConfigControllerApi* | [**access_config_controller_find_by_id**](docs/AccessConfigControllerApi.md#access_config_controller_find_by_id) | **GET** /access-configs/{id} | 
*AccessConfigControllerApi* | [**access_config_controller_update_all**](docs/AccessConfigControllerApi.md#access_config_controller_update_all) | **PATCH** /access-configs | 
*AccessConfigControllerApi* | [**access_config_controller_update_by_id**](docs/AccessConfigControllerApi.md#access_config_controller_update_by_id) | **PATCH** /access-configs/{id} | 
*BeamlineControllerApi* | [**beamline_controller_count**](docs/BeamlineControllerApi.md#beamline_controller_count) | **GET** /beamlines/count | 
*BeamlineControllerApi* | [**beamline_controller_create**](docs/BeamlineControllerApi.md#beamline_controller_create) | **POST** /beamlines | 
*BeamlineControllerApi* | [**beamline_controller_delete_by_id**](docs/BeamlineControllerApi.md#beamline_controller_delete_by_id) | **DELETE** /beamlines/{id} | 
*BeamlineControllerApi* | [**beamline_controller_find**](docs/BeamlineControllerApi.md#beamline_controller_find) | **GET** /beamlines | 
*BeamlineControllerApi* | [**beamline_controller_find_by_id**](docs/BeamlineControllerApi.md#beamline_controller_find_by_id) | **GET** /beamlines/{id} | 
*BeamlineControllerApi* | [**beamline_controller_update_all**](docs/BeamlineControllerApi.md#beamline_controller_update_all) | **PATCH** /beamlines | 
*BeamlineControllerApi* | [**beamline_controller_update_by_id**](docs/BeamlineControllerApi.md#beamline_controller_update_by_id) | **PATCH** /beamlines/{id} | 
*DatasetControllerApi* | [**dataset_controller_count**](docs/DatasetControllerApi.md#dataset_controller_count) | **GET** /datasets/count | 
*DatasetControllerApi* | [**dataset_controller_create**](docs/DatasetControllerApi.md#dataset_controller_create) | **POST** /datasets | 
*DatasetControllerApi* | [**dataset_controller_delete_by_id**](docs/DatasetControllerApi.md#dataset_controller_delete_by_id) | **DELETE** /datasets/{id} | 
*DatasetControllerApi* | [**dataset_controller_find**](docs/DatasetControllerApi.md#dataset_controller_find) | **GET** /datasets | 
*DatasetControllerApi* | [**dataset_controller_find_by_id**](docs/DatasetControllerApi.md#dataset_controller_find_by_id) | **GET** /datasets/{id} | 
*DatasetControllerApi* | [**dataset_controller_update_all**](docs/DatasetControllerApi.md#dataset_controller_update_all) | **PATCH** /datasets | 
*DatasetControllerApi* | [**dataset_controller_update_by_id**](docs/DatasetControllerApi.md#dataset_controller_update_by_id) | **PATCH** /datasets/{id} | 
*DeviceControllerApi* | [**device_controller_count**](docs/DeviceControllerApi.md#device_controller_count) | **GET** /devices/count | 
*DeviceControllerApi* | [**device_controller_create**](docs/DeviceControllerApi.md#device_controller_create) | **POST** /devices | 
*DeviceControllerApi* | [**device_controller_delete_by_id**](docs/DeviceControllerApi.md#device_controller_delete_by_id) | **DELETE** /devices/{id} | 
*DeviceControllerApi* | [**device_controller_find**](docs/DeviceControllerApi.md#device_controller_find) | **GET** /devices | 
*DeviceControllerApi* | [**device_controller_find_by_id**](docs/DeviceControllerApi.md#device_controller_find_by_id) | **GET** /devices/{id} | 
*DeviceControllerApi* | [**device_controller_update_all**](docs/DeviceControllerApi.md#device_controller_update_all) | **PATCH** /devices | 
*DeviceControllerApi* | [**device_controller_update_by_id**](docs/DeviceControllerApi.md#device_controller_update_by_id) | **PATCH** /devices/{id} | 
*ExperimentAccountControllerApi* | [**experiment_account_controller_count**](docs/ExperimentAccountControllerApi.md#experiment_account_controller_count) | **GET** /experiment-accounts/count | 
*ExperimentAccountControllerApi* | [**experiment_account_controller_create**](docs/ExperimentAccountControllerApi.md#experiment_account_controller_create) | **POST** /experiment-accounts | 
*ExperimentAccountControllerApi* | [**experiment_account_controller_delete_by_id**](docs/ExperimentAccountControllerApi.md#experiment_account_controller_delete_by_id) | **DELETE** /experiment-accounts/{id} | 
*ExperimentAccountControllerApi* | [**experiment_account_controller_find**](docs/ExperimentAccountControllerApi.md#experiment_account_controller_find) | **GET** /experiment-accounts | 
*ExperimentAccountControllerApi* | [**experiment_account_controller_find_by_id**](docs/ExperimentAccountControllerApi.md#experiment_account_controller_find_by_id) | **GET** /experiment-accounts/{id} | 
*ExperimentAccountControllerApi* | [**experiment_account_controller_update_all**](docs/ExperimentAccountControllerApi.md#experiment_account_controller_update_all) | **PATCH** /experiment-accounts | 
*ExperimentAccountControllerApi* | [**experiment_account_controller_update_by_id**](docs/ExperimentAccountControllerApi.md#experiment_account_controller_update_by_id) | **PATCH** /experiment-accounts/{id} | 
*ExperimentControllerApi* | [**experiment_controller_count**](docs/ExperimentControllerApi.md#experiment_controller_count) | **GET** /experiments/count | 
*ExperimentControllerApi* | [**experiment_controller_create**](docs/ExperimentControllerApi.md#experiment_controller_create) | **POST** /experiments | 
*ExperimentControllerApi* | [**experiment_controller_delete_by_id**](docs/ExperimentControllerApi.md#experiment_controller_delete_by_id) | **DELETE** /experiments/{id} | 
*ExperimentControllerApi* | [**experiment_controller_find**](docs/ExperimentControllerApi.md#experiment_controller_find) | **GET** /experiments | 
*ExperimentControllerApi* | [**experiment_controller_find_by_id**](docs/ExperimentControllerApi.md#experiment_controller_find_by_id) | **GET** /experiments/{id} | 
*ExperimentControllerApi* | [**experiment_controller_update_all**](docs/ExperimentControllerApi.md#experiment_controller_update_all) | **PATCH** /experiments | 
*ExperimentControllerApi* | [**experiment_controller_update_by_id**](docs/ExperimentControllerApi.md#experiment_controller_update_by_id) | **PATCH** /experiments/{id} | 
*FunctionalAccountControllerApi* | [**functional_account_controller_count**](docs/FunctionalAccountControllerApi.md#functional_account_controller_count) | **GET** /functional-accounts/count | 
*FunctionalAccountControllerApi* | [**functional_account_controller_create**](docs/FunctionalAccountControllerApi.md#functional_account_controller_create) | **POST** /functional-accounts | 
*FunctionalAccountControllerApi* | [**functional_account_controller_delete_by_id**](docs/FunctionalAccountControllerApi.md#functional_account_controller_delete_by_id) | **DELETE** /functional-accounts/{id} | 
*FunctionalAccountControllerApi* | [**functional_account_controller_find**](docs/FunctionalAccountControllerApi.md#functional_account_controller_find) | **GET** /functional-accounts | 
*FunctionalAccountControllerApi* | [**functional_account_controller_find_by_id**](docs/FunctionalAccountControllerApi.md#functional_account_controller_find_by_id) | **GET** /functional-accounts/{id} | 
*FunctionalAccountControllerApi* | [**functional_account_controller_update_all**](docs/FunctionalAccountControllerApi.md#functional_account_controller_update_all) | **PATCH** /functional-accounts | 
*FunctionalAccountControllerApi* | [**functional_account_controller_update_by_id**](docs/FunctionalAccountControllerApi.md#functional_account_controller_update_by_id) | **PATCH** /functional-accounts/{id} | 
*NXEntityControllerApi* | [**n_x_entity_controller_count**](docs/NXEntityControllerApi.md#n_x_entity_controller_count) | **GET** /nxentities/count | 
*NXEntityControllerApi* | [**n_x_entity_controller_create**](docs/NXEntityControllerApi.md#n_x_entity_controller_create) | **POST** /nxentities | 
*NXEntityControllerApi* | [**n_x_entity_controller_create_entry**](docs/NXEntityControllerApi.md#n_x_entity_controller_create_entry) | **POST** /nxentities/entry | 
*NXEntityControllerApi* | [**n_x_entity_controller_delete_by_id**](docs/NXEntityControllerApi.md#n_x_entity_controller_delete_by_id) | **DELETE** /nxentities/{id} | 
*NXEntityControllerApi* | [**n_x_entity_controller_find**](docs/NXEntityControllerApi.md#n_x_entity_controller_find) | **GET** /nxentities | 
*NXEntityControllerApi* | [**n_x_entity_controller_find_by_id**](docs/NXEntityControllerApi.md#n_x_entity_controller_find_by_id) | **GET** /nxentities/{id} | 
*NXEntityControllerApi* | [**n_x_entity_controller_replace_by_id**](docs/NXEntityControllerApi.md#n_x_entity_controller_replace_by_id) | **PUT** /nxentities/{id} | 
*NXEntityControllerApi* | [**n_x_entity_controller_update_all**](docs/NXEntityControllerApi.md#n_x_entity_controller_update_all) | **PATCH** /nxentities | 
*NXEntityControllerApi* | [**n_x_entity_controller_update_by_id**](docs/NXEntityControllerApi.md#n_x_entity_controller_update_by_id) | **PATCH** /nxentities/{id} | 
*OIDCControllerApi* | [**o_idc_controller_login_to_third_party**](docs/OIDCControllerApi.md#o_idc_controller_login_to_third_party) | **GET** /auth/login | 
*OIDCControllerApi* | [**o_idc_controller_logout**](docs/OIDCControllerApi.md#o_idc_controller_logout) | **GET** /auth/logout | 
*OIDCControllerApi* | [**o_idc_controller_third_party_call_back**](docs/OIDCControllerApi.md#o_idc_controller_third_party_call_back) | **GET** /auth/callback | 
*ScanControllerApi* | [**scan_controller_count**](docs/ScanControllerApi.md#scan_controller_count) | **GET** /scans/count | 
*ScanControllerApi* | [**scan_controller_create**](docs/ScanControllerApi.md#scan_controller_create) | **POST** /scans | 
*ScanControllerApi* | [**scan_controller_delete_by_id**](docs/ScanControllerApi.md#scan_controller_delete_by_id) | **DELETE** /scans/{id} | 
*ScanControllerApi* | [**scan_controller_find**](docs/ScanControllerApi.md#scan_controller_find) | **GET** /scans | 
*ScanControllerApi* | [**scan_controller_find_by_id**](docs/ScanControllerApi.md#scan_controller_find_by_id) | **GET** /scans/{id} | 
*ScanControllerApi* | [**scan_controller_update_all**](docs/ScanControllerApi.md#scan_controller_update_all) | **PATCH** /scans | 
*ScanControllerApi* | [**scan_controller_update_by_id**](docs/ScanControllerApi.md#scan_controller_update_by_id) | **PATCH** /scans/{id} | 
*ScanDataControllerApi* | [**scan_data_controller_count**](docs/ScanDataControllerApi.md#scan_data_controller_count) | **GET** /scan-data/count | 
*ScanDataControllerApi* | [**scan_data_controller_create**](docs/ScanDataControllerApi.md#scan_data_controller_create) | **POST** /scan-data | 
*ScanDataControllerApi* | [**scan_data_controller_create_many**](docs/ScanDataControllerApi.md#scan_data_controller_create_many) | **POST** /scan-data/many | 
*ScanDataControllerApi* | [**scan_data_controller_delete_by_id**](docs/ScanDataControllerApi.md#scan_data_controller_delete_by_id) | **DELETE** /scan-data/{id} | 
*ScanDataControllerApi* | [**scan_data_controller_find**](docs/ScanDataControllerApi.md#scan_data_controller_find) | **GET** /scan-data | 
*ScanDataControllerApi* | [**scan_data_controller_find_by_id**](docs/ScanDataControllerApi.md#scan_data_controller_find_by_id) | **GET** /scan-data/{id} | 
*ScanDataControllerApi* | [**scan_data_controller_replace_by_id**](docs/ScanDataControllerApi.md#scan_data_controller_replace_by_id) | **PUT** /scan-data/{id} | 
*ScanDataControllerApi* | [**scan_data_controller_update_all**](docs/ScanDataControllerApi.md#scan_data_controller_update_all) | **PATCH** /scan-data | 
*ScanDataControllerApi* | [**scan_data_controller_update_by_id**](docs/ScanDataControllerApi.md#scan_data_controller_update_by_id) | **PATCH** /scan-data/{id} | 
*SessionControllerApi* | [**session_controller_count**](docs/SessionControllerApi.md#session_controller_count) | **GET** /sessions/count | 
*SessionControllerApi* | [**session_controller_create**](docs/SessionControllerApi.md#session_controller_create) | **POST** /sessions | 
*SessionControllerApi* | [**session_controller_delete_by_id**](docs/SessionControllerApi.md#session_controller_delete_by_id) | **DELETE** /sessions/{id} | 
*SessionControllerApi* | [**session_controller_find**](docs/SessionControllerApi.md#session_controller_find) | **GET** /sessions | 
*SessionControllerApi* | [**session_controller_find_by_id**](docs/SessionControllerApi.md#session_controller_find_by_id) | **GET** /sessions/{id} | 
*SessionControllerApi* | [**session_controller_update_all**](docs/SessionControllerApi.md#session_controller_update_all) | **PATCH** /sessions | 
*SessionControllerApi* | [**session_controller_update_by_id**](docs/SessionControllerApi.md#session_controller_update_by_id) | **PATCH** /sessions/{id} | 
*UserControllerApi* | [**user_controller_create**](docs/UserControllerApi.md#user_controller_create) | **POST** /users | 
*UserControllerApi* | [**user_controller_find_by_id**](docs/UserControllerApi.md#user_controller_find_by_id) | **GET** /users/{userId} | 
*UserControllerApi* | [**user_controller_login**](docs/UserControllerApi.md#user_controller_login) | **POST** /users/login | 
*UserControllerApi* | [**user_controller_print_current_user**](docs/UserControllerApi.md#user_controller_print_current_user) | **GET** /users/me | 


## Documentation For Models

 - [AccessAccount](docs/AccessAccount.md)
 - [AccessAccountFields](docs/AccessAccountFields.md)
 - [AccessAccountFieldsOneOf](docs/AccessAccountFieldsOneOf.md)
 - [AccessAccountFilter](docs/AccessAccountFilter.md)
 - [AccessAccountFilter1](docs/AccessAccountFilter1.md)
 - [AccessAccountFilterOrder](docs/AccessAccountFilterOrder.md)
 - [AccessAccountPartial](docs/AccessAccountPartial.md)
 - [AccessAccountWithRelations](docs/AccessAccountWithRelations.md)
 - [AccessConfig](docs/AccessConfig.md)
 - [AccessConfigFields](docs/AccessConfigFields.md)
 - [AccessConfigFieldsOneOf](docs/AccessConfigFieldsOneOf.md)
 - [AccessConfigFilter](docs/AccessConfigFilter.md)
 - [AccessConfigFilter1](docs/AccessConfigFilter1.md)
 - [AccessConfigIncludeFilterInner](docs/AccessConfigIncludeFilterInner.md)
 - [AccessConfigIncludeFilterItems](docs/AccessConfigIncludeFilterItems.md)
 - [AccessConfigPartial](docs/AccessConfigPartial.md)
 - [AccessConfigScopeFilter](docs/AccessConfigScopeFilter.md)
 - [AccessConfigScopeFilterFields](docs/AccessConfigScopeFilterFields.md)
 - [AccessConfigWithRelations](docs/AccessConfigWithRelations.md)
 - [Beamline](docs/Beamline.md)
 - [BeamlineFields](docs/BeamlineFields.md)
 - [BeamlineFieldsOneOf](docs/BeamlineFieldsOneOf.md)
 - [BeamlineFilter](docs/BeamlineFilter.md)
 - [BeamlineFilter1](docs/BeamlineFilter1.md)
 - [BeamlineIncludeFilterInner](docs/BeamlineIncludeFilterInner.md)
 - [BeamlineIncludeFilterItems](docs/BeamlineIncludeFilterItems.md)
 - [BeamlinePartial](docs/BeamlinePartial.md)
 - [BeamlineScopeFilter](docs/BeamlineScopeFilter.md)
 - [BeamlineWithRelations](docs/BeamlineWithRelations.md)
 - [Dataset](docs/Dataset.md)
 - [DatasetFields](docs/DatasetFields.md)
 - [DatasetFieldsOneOf](docs/DatasetFieldsOneOf.md)
 - [DatasetFilter](docs/DatasetFilter.md)
 - [DatasetFilter1](docs/DatasetFilter1.md)
 - [DatasetIncludeFilterInner](docs/DatasetIncludeFilterInner.md)
 - [DatasetIncludeFilterItems](docs/DatasetIncludeFilterItems.md)
 - [DatasetPartial](docs/DatasetPartial.md)
 - [DatasetScopeFilter](docs/DatasetScopeFilter.md)
 - [DatasetWithRelations](docs/DatasetWithRelations.md)
 - [Device](docs/Device.md)
 - [DeviceFields](docs/DeviceFields.md)
 - [DeviceFieldsOneOf](docs/DeviceFieldsOneOf.md)
 - [DeviceFilter](docs/DeviceFilter.md)
 - [DeviceFilter1](docs/DeviceFilter1.md)
 - [DeviceIncludeFilterInner](docs/DeviceIncludeFilterInner.md)
 - [DeviceIncludeFilterItems](docs/DeviceIncludeFilterItems.md)
 - [DevicePartial](docs/DevicePartial.md)
 - [DeviceScopeFilter](docs/DeviceScopeFilter.md)
 - [DeviceWithRelations](docs/DeviceWithRelations.md)
 - [Experiment](docs/Experiment.md)
 - [ExperimentAccount](docs/ExperimentAccount.md)
 - [ExperimentAccountFields](docs/ExperimentAccountFields.md)
 - [ExperimentAccountFieldsOneOf](docs/ExperimentAccountFieldsOneOf.md)
 - [ExperimentAccountFilter](docs/ExperimentAccountFilter.md)
 - [ExperimentAccountFilter1](docs/ExperimentAccountFilter1.md)
 - [ExperimentAccountIncludeFilterInner](docs/ExperimentAccountIncludeFilterInner.md)
 - [ExperimentAccountIncludeFilterItems](docs/ExperimentAccountIncludeFilterItems.md)
 - [ExperimentAccountPartial](docs/ExperimentAccountPartial.md)
 - [ExperimentAccountScopeFilter](docs/ExperimentAccountScopeFilter.md)
 - [ExperimentAccountWithRelations](docs/ExperimentAccountWithRelations.md)
 - [ExperimentFields](docs/ExperimentFields.md)
 - [ExperimentFieldsOneOf](docs/ExperimentFieldsOneOf.md)
 - [ExperimentFilter](docs/ExperimentFilter.md)
 - [ExperimentFilter1](docs/ExperimentFilter1.md)
 - [ExperimentIncludeFilterInner](docs/ExperimentIncludeFilterInner.md)
 - [ExperimentIncludeFilterItems](docs/ExperimentIncludeFilterItems.md)
 - [ExperimentPartial](docs/ExperimentPartial.md)
 - [ExperimentScopeFilter](docs/ExperimentScopeFilter.md)
 - [ExperimentWithRelations](docs/ExperimentWithRelations.md)
 - [FunctionalAccount](docs/FunctionalAccount.md)
 - [FunctionalAccountFields](docs/FunctionalAccountFields.md)
 - [FunctionalAccountFieldsOneOf](docs/FunctionalAccountFieldsOneOf.md)
 - [FunctionalAccountFilter](docs/FunctionalAccountFilter.md)
 - [FunctionalAccountFilter1](docs/FunctionalAccountFilter1.md)
 - [FunctionalAccountIncludeFilterInner](docs/FunctionalAccountIncludeFilterInner.md)
 - [FunctionalAccountIncludeFilterItems](docs/FunctionalAccountIncludeFilterItems.md)
 - [FunctionalAccountPartial](docs/FunctionalAccountPartial.md)
 - [FunctionalAccountScopeFilter](docs/FunctionalAccountScopeFilter.md)
 - [FunctionalAccountWithRelations](docs/FunctionalAccountWithRelations.md)
 - [LoopbackCount](docs/LoopbackCount.md)
 - [NXEntity](docs/NXEntity.md)
 - [NXEntityFields](docs/NXEntityFields.md)
 - [NXEntityFieldsOneOf](docs/NXEntityFieldsOneOf.md)
 - [NXEntityFilter](docs/NXEntityFilter.md)
 - [NXEntityFilter1](docs/NXEntityFilter1.md)
 - [NXEntityIncludeFilterInner](docs/NXEntityIncludeFilterInner.md)
 - [NXEntityIncludeFilterItems](docs/NXEntityIncludeFilterItems.md)
 - [NXEntityNested](docs/NXEntityNested.md)
 - [NXEntityPartial](docs/NXEntityPartial.md)
 - [NXEntityScopeFilter](docs/NXEntityScopeFilter.md)
 - [NXEntityWithRelations](docs/NXEntityWithRelations.md)
 - [NewAccessAccount](docs/NewAccessAccount.md)
 - [NewAccessConfig](docs/NewAccessConfig.md)
 - [NewBeamline](docs/NewBeamline.md)
 - [NewDataset](docs/NewDataset.md)
 - [NewDevice](docs/NewDevice.md)
 - [NewExperiment](docs/NewExperiment.md)
 - [NewExperimentAccount](docs/NewExperimentAccount.md)
 - [NewFunctionalAccount](docs/NewFunctionalAccount.md)
 - [NewNXEntity](docs/NewNXEntity.md)
 - [NewNXEntityNested](docs/NewNXEntityNested.md)
 - [NewScan](docs/NewScan.md)
 - [NewScanData](docs/NewScanData.md)
 - [NewScanDataMany](docs/NewScanDataMany.md)
 - [NewSession](docs/NewSession.md)
 - [NewUser](docs/NewUser.md)
 - [NewUserRequest](docs/NewUserRequest.md)
 - [Scan](docs/Scan.md)
 - [ScanData](docs/ScanData.md)
 - [ScanDataFields](docs/ScanDataFields.md)
 - [ScanDataFieldsOneOf](docs/ScanDataFieldsOneOf.md)
 - [ScanDataFilter](docs/ScanDataFilter.md)
 - [ScanDataFilter1](docs/ScanDataFilter1.md)
 - [ScanDataIncludeFilterInner](docs/ScanDataIncludeFilterInner.md)
 - [ScanDataIncludeFilterItems](docs/ScanDataIncludeFilterItems.md)
 - [ScanDataPartial](docs/ScanDataPartial.md)
 - [ScanDataScopeFilter](docs/ScanDataScopeFilter.md)
 - [ScanDataWithRelations](docs/ScanDataWithRelations.md)
 - [ScanFields](docs/ScanFields.md)
 - [ScanFieldsOneOf](docs/ScanFieldsOneOf.md)
 - [ScanFilter](docs/ScanFilter.md)
 - [ScanFilter1](docs/ScanFilter1.md)
 - [ScanIncludeFilterInner](docs/ScanIncludeFilterInner.md)
 - [ScanIncludeFilterItems](docs/ScanIncludeFilterItems.md)
 - [ScanPartial](docs/ScanPartial.md)
 - [ScanScopeFilter](docs/ScanScopeFilter.md)
 - [ScanWithRelations](docs/ScanWithRelations.md)
 - [Session](docs/Session.md)
 - [SessionFields](docs/SessionFields.md)
 - [SessionFieldsOneOf](docs/SessionFieldsOneOf.md)
 - [SessionFilter](docs/SessionFilter.md)
 - [SessionFilter1](docs/SessionFilter1.md)
 - [SessionIncludeFilterInner](docs/SessionIncludeFilterInner.md)
 - [SessionIncludeFilterItems](docs/SessionIncludeFilterItems.md)
 - [SessionPartial](docs/SessionPartial.md)
 - [SessionScopeFilter](docs/SessionScopeFilter.md)
 - [SessionWithRelations](docs/SessionWithRelations.md)
 - [User](docs/User.md)
 - [UserControllerLogin200Response](docs/UserControllerLogin200Response.md)
 - [UserControllerLoginRequest](docs/UserControllerLoginRequest.md)
 - [UserControllerPrintCurrentUser200Response](docs/UserControllerPrintCurrentUser200Response.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="jwt"></a>
### jwt

- **Type**: Bearer authentication (JWT)


## Author

klaus.wakonig@psi.ch


